fs = require 'fs'
path = require 'path'
_ = require 'underscore'

argon = require 'argon'
out = (require 'styout').instance 'octo.io'

exports.scan = (root) ->
  [roots, {options, callbacks}] = argon.ize arguments,
    name: 'scan'
    requiredArgs: ['file/dir']
    events: ['dirFound', 'fileFound', 'scanComplete']
    defaultOptions:
      ignoreFiles: {}

  pending = {}
  if _.last(root) is '/'
    recurse = false
    root = root[0...-1]
  else
    recurse = true
  
  statCallback = (relPath) ->
    filePath = path.join root, relPath
    pending[filePath] = 1
    (err, stats) ->
      if err
        if relPath is '.' then out.warn "<b>#{root}</b> does not exist"
        delete pending[filePath]
        callbacks.scanComplete?({root, options}) if _.isEmpty pending
        
      else if stats.isDirectory()
        fs.readdir filePath, (err, files) ->
          if err
            out.debug "Error in readDir callback: <b>#{err}</b>"
          else
            out.debug "dirFound: #{filePath}"
            callbacks.dirFound? filePath, {root, relPath, options}
            if recurse or relPath is '.' then for file in files
              fileRelPath = path.join relPath, file
              unless options.ignoreFiles[path.join(root, fileRelPath)]
                fs.lstat path.join(root, fileRelPath), statCallback(fileRelPath)
          delete pending[filePath]
          callbacks.scanComplete?({root, options}) if _.isEmpty(pending) and _.isEmpty(files)
          
      else
        fs.readFile filePath, 'utf8', (err, data) ->
          if err
            out.debug "Error in readFile callback: <b>#{err}</b>"
          else
            out.debug "fileFound: #{filePath}"
            callbacks.fileFound? filePath, {root, relPath, options}
          delete pending[filePath]
          callbacks.scanComplete?({root, options}) if _.isEmpty pending

  fs.lstat root, statCallback '.' unless options.ignoreFiles[root]